<template>
    <div class="hero bg-cover min-h-screen min-w-screen" :style="{ backgroundImage: `url(${heroBackgroundImage})` }">
        <div class="hero-overlay bg-opacity-60"></div>
        <div class="glass hero-content text-center text-neutral-content rounded-lg p-4 my-12">
            
            <div class="max-w-md" v-if="authenticated === false"> 
                <h1 class="mb-5 text-5xl font-bold">GreenIFTTT</h1>
                <p class="mb-5">
                    Welcome to GreenIFTTT, the app that transforms your home into an efficient and sustainable ecosystem! Optimize your energy consumption, reduce waste, and make the most of the resources available to you. Start living more sustainably, one step at a time.
                </p>
                <router-link to="/login" class="btn btn-primary w-full mb-2">Login User</router-link>
                <router-link to="/register" class="btn btn-primary w-full">Register User</router-link>
            </div>

            <div class="" v-if="authenticated">
                <div class="container mx-auto my-5">
                    
                    <!-- Page Title Card -->
                    <div class="card card-side bg-base-100 shadow-xl my-10">
                        <figure>
                            <div class="avatar">
                                <div class="w-20 rounded-full ring ring-primary ring-offset-base-100 ring-offset-2 m-5">
                                    <img src="@/assets/avatars/user_avatar.jpg" />
                                </div>
                            </div>
                        </figure>
                        <div class="card-body">
                            <h2 class="text-2xl font-bold">Welcome back, {{ userData.name }}!</h2>
                            <h1 class="font-light">Email: {{ userData.email }}</h1>
                        </div>
                    </div>

                    <PageTitle title="Sections" />

                    <div class="grid grid-cols-2 gap-4">
                        <div class="my-2">
                            <router-link to="/charts"><HomeCard title="Charts" description="Visualize energy consumption and savings" icon="monitoring" /></router-link>
                        </div>
                        <div class="my-2">
                            <router-link to="/devices"><HomeCard title="Devices" description="Manage your house appliances" icon="devices" /></router-link>
                        </div>
                        <div class="my-2">
                            <router-link to="/routines"><HomeCard title="Routines" description="Create and manage routines" icon="routine" /></router-link>
                        </div>
                        <div class="my-2">
                            <router-link to="/chat"><HomeCard title="ChatBot" description="Interact with the chatbot" icon="chat" /></router-link>
                        </div>
                    </div>

                    <!-- Numbers -->
                    <PageTitle title="Numbers" />
                    <div class="grid grid-cols-2 gap-4">
                        <!-- TODO: aggiungere icons nei numeri... -->
                        <Number class="my-2" title="Today Consumption (in Wh)" :number="formattedTodayConsumptions" />
                        <Number class="my-2" :title="'Last Week Consumption (in Wh)<br/><small>' + oneWeekAgo + '</small>'" :number="formattedLastWeekConsumptions" />
                    </div>
                    <PageTitle title="Other Numbers" />
                    <div class="grid sm:grid-cols-1 md:grid-cols-4 lg:grid-cols-4 gap-4">
                        <!-- TODO: aggiungere icons nei numeri... -->
                        <Number class="my-2" title="Devices" :number="(devices.length ? devices.length : '0')" />
                        <Number class="my-2" title="Registered Events" :number="((devices.reduce((total, device) => total + device.logs.length, 0)) ? (devices.reduce((total, device) => total + device.logs.length, 0)) : '0')" />
                        <Number class="my-2" title="Routines" :number="(routines ? routines : '0')" />
                        <Number class="my-2" title="Activities" :number="(activities ? activities : '0')" />
                    </div>

                    <!-- Charts -->
                    <PageTitle title="Charts" />
                    <div class="grid sm:grid-cols-1 md:grid-cols-2 lg:grid-cols-2 gap-4 mb-5">
                        <div>
                            <label>From</label>
                            <input class="glass input w-full text-gray-800" type="date" v-model="chartFrom" :max="chartTo" />
                        </div>
                        <div>
                            <label>To</label>
                            <input class="glass input w-full text-gray-800" type="date" v-model="chartTo" :min="chartFrom" />
                        </div>
                    </div>
                    <Doughnut v-if="chartData.datasets.length > 0 && chartData.datasets[0].data.length > 0" class="p-5 bg-opacity-50 bg-gray-900 rounded-md" :data="chartData" :options="chartOptions" />
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    import store from '@/store';
    import heroImage from '@/assets/bg_1.jpg'

    import HomeCard from '@/components/HomeCard.vue';
    import PageTitle from '@/components/PageTitle.vue';
    import Number from '@/components/Number.vue';
    
    import {
        Chart as ChartJS,
        ArcElement,
        Title,
        Tooltip,
        Legend
    } from 'chart.js'
    import { Doughnut } from 'vue-chartjs';
    
    ChartJS.register(
        ArcElement,
        Title,
        Tooltip,
        Legend
    )

    export default {
        components: {
            HomeCard,
            PageTitle,
            Number,
            Doughnut
        },
        data: () => {
            return {
                heroBackgroundImage: heroImage,
                authenticated: false,

                userData: {},
                devices: [],
                routines: 0,
                activities: 0,
                oneWeekAgo: new Date(new Date().setDate(new Date().getDate() - 7)).toISOString().split('T')[0],
                deviceColors: [],

                todayConsumptions: 0,
                lastWeekConsumptions: 0,

                chartFrom: '',
                chartTo: '',
                chartData: {
                    labels: [],
                    datasets: [{ data: []}]
                },
                chartOptions: {
                    responsive: true,
                    maintainAspectRatio: true,
                    plugins: {
                        title: {
                            display: true,
                            text: 'Total Consumption [kWh] per Device',
                            color: '#FFFFF0',
                            font: {
                                size: 18
                            }
                        },
                        legend: {
                            display: true,
                            labels: {
                                color: '#FFFFF0',
                            }
                        },
                        colorschemes: {
                            scheme: 'brewer.Paired12'
                        },
                    },
                }
            }
        },
        mounted() {
            var self = this;

            // set the default values for the chart
            this.chartFrom = new Date().toISOString().split('T')[0];
            this.chartTo = new Date().toISOString().split('T')[0];
            // check if the user is authenticated
            if (store.getUserToken() != null) {
                self.authenticated = true;
                
                // if any, get user data
                self.$axios.get('/user').then(function (response) {
                    self.userData = response.data;
                    self.userData.name = self.userData.name.charAt(0).toUpperCase() + self.userData.name.slice(1);
                }).catch(function (error) {
                    console.warn(error);
                });

                // get user routines and activities
                self.$axios.get('/routines').then(function (response) {
                    self.routines = response.data.length || 0;
                    self.activities = 0;
                    for(let routine of response.data) {
                        // get activities of each routine
                        self.$axios.get('/activities/findByRoutine?routineId=' + routine.id).then(function (r1) {
                            self.activities += r1.data.length || 0;
                        }).catch(function (error) {
                            console.warn(error);
                        });
                    }
                }).catch(function (error) {
                    console.warn(error);
                });

                // get all device consumptions & create range
                this.getConsumptions(true)

                // listen for updates on realtime consumptions
                this.socket = new WebSocket(this.WS_URL);
                this.socket.onopen = () => {
                    console.log('WebSocket Client Connected');
                };
                this.socket.onmessage = (msg) => {
                    msg = JSON.parse(msg.data)
                    if (msg.type === "REGISTERED_CONSUMPTION" && self.devices.includes(msg.device)) {
                        // self.getConsumptions(false)
                        self.updateConsumptions(parseFloat(msg.value))
                    }
                };
            } else {
                self.authenticated = false;
            }
        },
        computed: {
            formattedTodayConsumptions() {
                return parseFloat(this.todayConsumptions).toFixed(2);
            },
            formattedLastWeekConsumptions() {
                return parseFloat(this.lastWeekConsumptions).toFixed(2);
            }
        },
        methods: {
            getConsumptions(firstTime) {
                var self = this;

                self.$axios.get('/stats').then(function (response) {
                    let allDevices = response.data.filter(device => (device.type !== 'humidity' && device.type !== 'temperature'));
                    self.devices = allDevices;
                    // the first time this function is called, I need to create the date range
                    if(firstTime){
                        self.todayConsumptions = 0;
                        self.lastWeekConsumptions = 0;
                        
                        let todayDate = new Date();
                        let lastWeekDate = new Date(); 
                        lastWeekDate.setDate(todayDate.getDate() - 7);

                        let allDates = []

                        const baseColor = "00d6aa";
                        const numberOfColors = allDevices.length;
                        const saturationOffset = 50;
                        const lightnessOffset = 50;
                        self.deviceColors = generateColorsHex(baseColor, numberOfColors, saturationOffset, lightnessOffset);
                        console.log(self.deviceColors)

                        allDevices.forEach(device => {
                            device.logs.forEach(log => {
                                // approfitto per aggiornare anche i consumi (di oggi e last week)
                                let logDate = new Date(log.timestamp);
                                if(logDate.toISOString().split('T')[0] === todayDate.toISOString().split('T')[0]){
                                    self.todayConsumptions += log.value;
                                }
                                if(logDate.toISOString().split('T')[0] === lastWeekDate.toISOString().split('T')[0]){
                                    self.lastWeekConsumptions += log.value;
                                }
                            })

                            let logsDate = device.logs.map(log => log.timestamp).map(str => new Date(str));
                            allDates.push(new Date(Math.min(...logsDate)))
                            allDates.push(new Date(Math.max(...logsDate)))
                        });

                        self.chartFrom = new Date(Math.min(...allDates)).toISOString().split('T')[0]
                        self.chartTo = new Date(Math.max(...allDates)).toISOString().split('T')[0]

                        // I send also the devices to be updated from the socket
                        if(self.socket !== null){
                            self.socket.send(JSON.stringify({
                                devices: allDevices.map(dev => dev.id)
                            }));
                        }
                    }

                    // create the dataset
                    self.chartData = {
                        labels: allDevices.map(device => device.name),
                        datasets: [{
                                data: Array(allDevices.length).fill(0),
                                label: 'Consumption [kWh]',
                                backgroundColor: self.deviceColors,
                                borderColor: self.deviceColors,
                                pointerBackgroundColor: self.deviceColors
                        }],
                    }

                    allDevices.forEach(device => {
                        let sortedLogs = device.logs.sort((a,b) => { return new Date(a.timestamp) - new Date(b.timestamp) });
                        let fromDate = new Date(self.chartFrom);
                        let toDate = new Date(self.chartTo);
                        toDate.setHours(23, 59, 59, 999);
                        let filteredLogs = sortedLogs.filter(logObj => {
                            let tsDate = new Date(logObj.timestamp);
                            return tsDate >= fromDate && tsDate <= toDate;
                        });

                        let lblIndex = self.chartData.labels.indexOf(device.name)
                        if(lblIndex != -1){
                            self.chartData.datasets[0].data[lblIndex] = filteredLogs.reduce((total, log) => total + log.value, 0);
                        }
                    })
                }).catch(function (error) {
                    console.warn(error);
                });
            },
            updateConsumptions(value) {
                var self = this;
                // aggiorno il contatore dei consumi giornalieri...
                self.todayConsumptions += value;
                self.getConsumptions(false)
                self.$forceUpdate();
            }
        },
        watch: {
            chartFrom: function (newVal, oldVal) {
                if(newVal != oldVal)
                    this.getConsumptions(false)
            },
            chartTo: function (newVal, oldVal) {
                if(newVal != oldVal)
                    this.getConsumptions(false)
            }
        },
    }

    function generateColorsHex(baseColor, numberOfColors, saturationOffset, lightnessOffset) {
        const baseHue = parseInt(baseColor.substring(1, 3), 16);
        const baseSaturation = parseInt(baseColor.substring(3, 5), 16);
        const baseLightness = parseInt(baseColor.substring(5, 7), 16);

        const colors = [];

        for (let i = 0; i < numberOfColors; i++) {
            const hue = (baseHue + i * 20) % 360; // Adjust the increment based on your preference
            const saturation = Math.min(100, baseSaturation + saturationOffset);
            const lightness = Math.min(100, baseLightness + lightnessOffset);

            const generatedColor = hslToHex(hue, saturation, lightness);
            colors.push(generatedColor);
        }

        return colors;
    }

    function hslToHex(h, s, l) {
        h /= 360;
        s /= 100;
        l /= 100;
        let r, g, b;

        if (s === 0) {
            r = g = b = l;
        } else {
            const hue2rgb = (p, q, t) => {
                if (t < 0) t += 1;
                if (t > 1) t -= 1;
                if (t < 1 / 6) return p + (q - p) * 6 * t;
                if (t < 1 / 2) return q;
                if (t < 2 / 3) return p + (q - p) * (2 / 3 - t) * 6;
                return p;
            };

            const q = l < 0.5 ? l * (1 + s) : l + s - l * s;
            const p = 2 * l - q;

            r = hue2rgb(p, q, h + 1 / 3);
            g = hue2rgb(p, q, h);
            b = hue2rgb(p, q, h - 1 / 3);
        }

        const toHex = (x) => {
            const hex = Math.round(x * 255).toString(16);
            return hex.length === 1 ? '0' + hex : hex;
        };

        return `#${toHex(r)}${toHex(g)}${toHex(b)}`;
    }
</script>

<style scoped>
</style>